#include <hmg.ch>

*--------------------
* Simple app for creating backup of *.prg and *fmg files
*
* Created 2012 by Marek Olszewski "MOL" mol@pro.onet.pl
*
*
*
* It's free software! You can change everything!
*
*
* This software is provided as it is
*
*----------------------


function main

	private cSourceFolder      := GetCurrentFolder(),;
           cDestinationFolder := ".\backups",;
           nArchiveNameCreatingMethod := 2 ,;
       	  cArchiveName       := "",; 
           lBackupStatus      := .f.,; 
           nOverwriteArchive  :=  0
           
           
	public cGlobalArchiveName
	
	private cAppFolder := substr(exename(),1,rat("\",exename())-1)
	
	cGlobalArchiveName := substr(cAppFolder,rat("\",cAppFolder)+1)
	
   
	if empty(cGlobalArchiveName)
		cGlobalArchiveName := "BACKUP"
	endif

	load window BackUp
	center window BackUp
	
	ON KEY ESCAPE OF BackUp ACTION BackUp.release
	ON KEY ALT+Q OF BackUp ACTION BackUp.release
	ON KEY F2 OF BackUp ACTION MakeBackup()
	
	BackUp.T_BackupName.Value   := cArchiveName
   BackUp.T_SourceFolder.Value := cSourceFolder
	backup.T_BackupFolder.Value := cDestinationFolder
	BackUp.R_ArchiveNameCreatingMethod.Value := nArchiveNameCreatingMethod
	BackUp.T_BackupName.ReadOnly := nArchiveNameCreatingMethod <> 3
	BackUp.CH_OverwriteBackupsWithoutWarning.Value := nOverwriteArchive > 0
	
	activate window BackUp
	
 return lBackupStatus
 
*-------------------
function SelectBackupHolder
	local cGetFolder
	cGetFolder := BrwFFolder( backup.T_BackupFolder.Value, GetCurrentFolder() )
	if !empty(cGetFolder)
		backup.T_BackupFolder.Value := cGetFolder
	endif
return
*-------------------

function SelectSourceFolder
	local cGetFolder
	cGetFolder := BrwFFolder( backup.T_BackupFolder.Value, GetCurrentFolder() )
	if !empty(cGetFolder)
		BackUp.T_SourceFolder.Value := cGetFolder
	endif
return
*-------------------

function CreateArchiveName
	local cArchiveName := ""
	
	cArchiveName := cGlobalArchiveName
	
	do case
		case BackUp.R_ArchiveNameCreatingMethod.Value == 1
			// only the name
			BackUp.T_BackupName.Value := cArchiveName
			BackUp.T_BackupName.ReadOnly := .t.
		case BackUp.R_ArchiveNameCreatingMethod.Value == 2
			// name + data
			BackUp.T_BackupName.Value := cArchiveName + "_"+dtos(date())+"_"+strtran(time(),":","")
			BackUp.T_BackupName.ReadOnly := .t.
		case BackUp.R_ArchiveNameCreatingMethod.Value == 3
			if empty(BackUp.T_BackupName.Value)
				// name + data
				BackUp.T_BackupName.Value := cArchiveName + "_"+dtos(date())+"_"+strtran(time(),":","")
			endif
			BackUp.T_BackupName.ReadOnly := .f.
	endcase
return
*-------------------

function MakeBackup

	local aFilesToBackup := {},; 
         cArchiveName   := "",;
         cFileKind      := ""
	
	cArchiveName := alltrim(backup.T_BackupFolder.Value)
   
	if substr(cArchiveName,-1) <> "\"
		cArchiveName += "\"
	endif
	
	if !file(cArchiveName+"nul")
		CreateFolder(cArchiveName)
		if !file(cArchiveName+"\nul")
			MsgStop("Creating archive folder unsuccessful! Operation stopped!")
			return
		endif
	endif
		
	cArchiveName += alltrim(BackUp.T_BackupName.Value) +".zip"
	
	if file(cArchiveName) .and. !BackUp.CH_OverwriteBackupsWithoutWarning.Value
		if !MsgYesNo("Backup file: " + cArchiveName + "already exists! Overwrite it?","Overwrite backup file?",.t.)
			return
		endif
	endif
	
	BackUp.ProgressIndicator.Visible := .t.
  
   
   aTemp := DIRECTORY( BackUp.T_SourceFolder.Value + "\*.*" )
   
   AEVAL( aTemp, { | a1 | AADD( aFilesToBackup, a1[ 1 ] ) } )
   
   IF EMPTY( aFilesToBackup )
      MsgStop( "No file found to backup !", " ERROR !" )    
   ELSE
      BackUp.ProgressIndicator.RangeMax := len(aFilesToBackup)
      BackUp.ProgressIndicator.Value := 0

      COMPRESS aFilesToBackup ;
         TO cArchiveName ;
         BLOCK {|cFile,nPos|  BackUp.ProgressIndicator.Value := nPos }  ;
         OVERWRITE
	
      lBackupStatus  := .t.
      msgbox("Backup created successful!") 
   ENDIF   
*	BackUp.Release
return
*-------------------
